// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:msg/RobotInfo.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MODE_NA'.
/**
  * mode
  * undefined mode
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__MODE_NA = 0l
};

/// Constant 'MODE_IDLE'.
/**
  * robot is idle
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__MODE_IDLE = 1l
};

/// Constant 'MODE_SEGMENT_FOLLOWING'.
/**
  * robot is in mode segment following
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__MODE_SEGMENT_FOLLOWING = 2l
};

/// Constant 'MODE_PICKUP'.
/**
  * robot is picking up goods
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__MODE_PICKUP = 3l
};

/// Constant 'STATUS_DRIVING'.
/**
  * status
  * robot is driving
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__STATUS_DRIVING = 0l
};

/// Constant 'STATUS_STOPPED'.
/**
  * robot has stopped
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__STATUS_STOPPED = 1l
};

/// Constant 'STATUS_DONE'.
/**
  * robot has finished its last job
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__STATUS_DONE = 2l
};

/// Constant 'STATUS_BROKEN'.
/**
  * robot is broken and not ready for any task
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__STATUS_BROKEN = 3l
};

/// Constant 'GOOD_EMPTY'.
/**
  * good_id
  * no goods attached
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__GOOD_EMPTY = -1l
};

/// Constant 'GOOD_NA'.
/**
  * undefined good
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__GOOD_NA = -2l
};

/// Constant 'SHAPE_CIRCLE'.
/**
  * shape
  * robot is in shape of a circle    ShapeVars
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__SHAPE_CIRCLE = 0l
};

/// Constant 'ORDER_NONE'.
/**
  * order_status
  * no order assigned
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__ORDER_NONE = 0l
};

/// Constant 'ORDER_APPROACH'.
/**
  * the robot approaches the first station of the order
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__ORDER_APPROACH = 1l
};

/// Constant 'ORDER_PICKUP'.
/**
  * the robot picks up a good at the station
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__ORDER_PICKUP = 2l
};

/// Constant 'ORDER_TRANSPORT'.
/**
  * the robot currently transports a good from one station to another
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__ORDER_TRANSPORT = 3l
};

/// Constant 'ORDER_DROP'.
/**
  * the robot drops a good at the last station of its order, finishing the order
 */
enum
{
  tuw_multi_robot_msgs__msg__RobotInfo__ORDER_DROP = 4l
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'robot_name'
#include "rosidl_runtime_c/string.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_with_covariance__struct.h"
// Member 'shape_variables'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'sync'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__struct.h"

/// Struct defined in msg/RobotInfo in the package tuw_multi_robot_msgs.
/**
  * Presents dynamic parameters of a robot
 */
typedef struct tuw_multi_robot_msgs__msg__RobotInfo
{
  /// the creation time
  std_msgs__msg__Header header;
  /// the name of the robot (used in preconditions and topics)
  rosidl_runtime_c__String robot_name;
  /// the robots current pose within the frame related to the msgs header
  geometry_msgs__msg__PoseWithCovariance pose;
  /// the shape of the robots (see enums)
  int32_t shape;
  /// shape variables to define width height, ...
  rosidl_runtime_c__float__Sequence shape_variables;
  /// the current position in the last received plan (-1 means none)
  tuw_multi_robot_msgs__msg__RoutePrecondition sync;
  /// the mode of operation
  int32_t mode;
  /// the status of the robot
  int32_t status;
  /// the good id attached to the robot
  int32_t good_id;
  /// the order id scheduled to this robot (-1: none)
  int32_t order_id;
  /// the status of the assigned order
  int32_t order_status;
} tuw_multi_robot_msgs__msg__RobotInfo;

// Struct for a sequence of tuw_multi_robot_msgs__msg__RobotInfo.
typedef struct tuw_multi_robot_msgs__msg__RobotInfo__Sequence
{
  tuw_multi_robot_msgs__msg__RobotInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__msg__RobotInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_
